/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ARRAY = 258,
     AS = 259,
     CAST = 260,
     COMMA = 261,
     DECLARE = 262,
     DOUBLECOLON = 263,
     EXPLAIN = 264,
     FUNCTION = 265,
     HELP = 266,
     INTO = 267,
     OF = 268,
     MEMBER = 269,
     POINTER = 270,
     REFERENCE = 271,
     RETURNING = 272,
     SET = 273,
     TO = 274,
     CHAR = 275,
     CLASS = 276,
     CONSTVOLATILE = 277,
     DOUBLE = 278,
     ENUM = 279,
     FLOAT = 280,
     INT = 281,
     LONG = 282,
     NAME = 283,
     NUMBER = 284,
     SHORT = 285,
     SIGNED = 286,
     STRUCT = 287,
     UNION = 288,
     UNSIGNED = 289,
     VOID = 290,
     AUTO = 291,
     EXTERN = 292,
     REGISTER = 293,
     STATIC = 294
   };
#endif
#define ARRAY 258
#define AS 259
#define CAST 260
#define COMMA 261
#define DECLARE 262
#define DOUBLECOLON 263
#define EXPLAIN 264
#define FUNCTION 265
#define HELP 266
#define INTO 267
#define OF 268
#define MEMBER 269
#define POINTER 270
#define REFERENCE 271
#define RETURNING 272
#define SET 273
#define TO 274
#define CHAR 275
#define CLASS 276
#define CONSTVOLATILE 277
#define DOUBLE 278
#define ENUM 279
#define FLOAT 280
#define INT 281
#define LONG 282
#define NAME 283
#define NUMBER 284
#define SHORT 285
#define SIGNED 286
#define STRUCT 287
#define UNION 288
#define UNSIGNED 289
#define VOID 290
#define AUTO 291
#define EXTERN 292
#define REGISTER 293
#define STATIC 294




/* Copy the first part of user declarations.  */
#line 1 "cdgram.y"

/* Yacc grammar for ANSI and C++ cdecl. */
/* The output of this file is included */
/* into the C file cdecl.c. */
char cdgramsccsid[] = "@(#)cdgram.y	2.2 3/30/88";


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 8 "cdgram.y"
typedef union YYSTYPE {
	char *dynstr;
	struct {
		char *left;
		char *right;
		char *type;
	} halves;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 169 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 181 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   195

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  48
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  26
/* YYNRULES -- Number of rules. */
#define YYNRULES  89
/* YYNRULES -- Number of states. */
#define YYNSTATES  163

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   294

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      42,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    45,     2,
      40,    41,    44,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    43,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,    47,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     7,    10,    17,    22,    28,    32,
      39,    45,    51,    60,    64,    66,    69,    71,    73,    75,
      76,    78,    82,    87,    91,    95,   100,   103,   107,   109,
     113,   117,   119,   120,   124,   126,   128,   132,   133,   136,
     142,   149,   153,   158,   161,   164,   167,   170,   174,   178,
     185,   190,   195,   204,   209,   212,   213,   215,   218,   219,
     221,   223,   226,   229,   231,   233,   235,   237,   239,   241,
     243,   245,   247,   249,   252,   254,   256,   258,   260,   262,
     264,   266,   269,   270,   273,   275,   277,   279,   281,   283
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      49,     0,    -1,    -1,    49,    50,    -1,    11,    51,    -1,
       7,    28,     4,    73,    59,    51,    -1,     7,    73,    59,
      51,    -1,     5,    28,    12,    59,    51,    -1,     5,    59,
      51,    -1,     9,    73,    70,    61,    53,    51,    -1,     9,
      72,    70,    53,    51,    -1,     9,    73,    71,    53,    51,
      -1,     9,    40,    70,    61,    57,    41,    52,    51,    -1,
      18,    52,    51,    -1,    51,    -1,     1,    51,    -1,    42,
      -1,    43,    -1,    28,    -1,    -1,    54,    -1,    44,    70,
      53,    -1,    28,     8,    44,    53,    -1,    45,    70,    53,
      -1,    54,    40,    41,    -1,    54,    40,    55,    41,    -1,
      54,    58,    -1,    40,    53,    41,    -1,    28,    -1,    55,
       6,    55,    -1,    70,    61,    57,    -1,    28,    -1,    -1,
      56,     6,    56,    -1,    28,    -1,    59,    -1,    28,     4,
      59,    -1,    -1,    40,    41,    -1,    40,    57,    41,    40,
      41,    -1,    40,    57,    41,    40,    55,    41,    -1,    40,
      57,    41,    -1,    28,     8,    44,    57,    -1,    44,    57,
      -1,    45,    57,    -1,    57,    58,    -1,    46,    47,    -1,
      46,    29,    47,    -1,    10,    17,    59,    -1,    10,    40,
      56,    41,    17,    59,    -1,     3,    60,    13,    59,    -1,
      70,    15,    19,    59,    -1,    70,    15,    19,    14,    13,
      65,    28,    59,    -1,    70,    16,    19,    59,    -1,    70,
      61,    -1,    -1,    29,    -1,    62,    63,    -1,    -1,    67,
      -1,    66,    -1,    67,    66,    -1,    64,    28,    -1,    65,
      -1,    24,    -1,    33,    -1,    32,    -1,    21,    -1,    26,
      -1,    20,    -1,    25,    -1,    23,    -1,    35,    -1,    69,
      68,    -1,    69,    -1,    67,    -1,    22,    -1,    34,    -1,
      31,    -1,    27,    -1,    30,    -1,    22,    70,    -1,    -1,
      22,    70,    -1,    36,    -1,    37,    -1,    38,    -1,    39,
      -1,    72,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    31,    31,    32,    39,    45,    57,    68,    78,    87,
      98,   108,   118,   129,   136,   137,   143,   147,   153,   161,
     167,   168,   178,   190,   203,   212,   223,   233,   242,   253,
     261,   270,   277,   282,   290,   297,   306,   318,   325,   333,
     342,   352,   361,   372,   381,   392,   403,   409,   417,   440,
     464,   494,   524,   558,   593,   617,   623,   632,   643,   649,
     656,   663,   671,   680,   681,   682,   688,   689,   695,   702,
     709,   716,   723,   731,   739,   747,   754,   768,   775,   782,
     789,   797,   812,   818,   833,   834,   835,   836,   843,   850
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ARRAY", "AS", "CAST", "COMMA", "DECLARE", 
  "DOUBLECOLON", "EXPLAIN", "FUNCTION", "HELP", "INTO", "OF", "MEMBER", 
  "POINTER", "REFERENCE", "RETURNING", "SET", "TO", "CHAR", "CLASS", 
  "CONSTVOLATILE", "DOUBLE", "ENUM", "FLOAT", "INT", "LONG", "NAME", 
  "NUMBER", "SHORT", "SIGNED", "STRUCT", "UNION", "UNSIGNED", "VOID", 
  "AUTO", "EXTERN", "REGISTER", "STATIC", "'('", "')'", "'\\n'", "';'", 
  "'*'", "'&'", "'['", "']'", "$accept", "prog", "stmt", "NL", "optNAME", 
  "cdecl", "cdecl1", "castlist", "adecllist", "cast", "cdims", "adecl", 
  "adims", "type", "tinit", "c_type", "StrClaUniEnum", "ClassStruct", 
  "tname", "mod_list", "mod_list1", "modifier", "opt_constvol_list", 
  "constvol_list", "storage", "opt_storage", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
      40,    41,    10,    59,    42,    38,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    48,    49,    49,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    51,    51,    52,    52,
      53,    53,    53,    53,    54,    54,    54,    54,    54,    55,
      55,    55,    56,    56,    56,    56,    56,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    58,    58,    59,    59,
      59,    59,    59,    59,    59,    60,    60,    61,    62,    63,
      63,    63,    63,    64,    64,    64,    65,    65,    66,    66,
      66,    66,    66,    67,    67,    68,    68,    69,    69,    69,
      69,    70,    70,    71,    72,    72,    72,    72,    73,    73
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     2,     6,     4,     5,     3,     6,
       5,     5,     8,     3,     1,     2,     1,     1,     1,     0,
       1,     3,     4,     3,     3,     4,     2,     3,     1,     3,
       3,     1,     0,     3,     1,     1,     3,     0,     2,     5,
       6,     3,     4,     2,     2,     2,     2,     3,     3,     6,
       4,     4,     8,     4,     2,     0,     1,     2,     0,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     2,     0,     2,     1,     1,     1,     1,     1,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,     0,    82,    89,    89,     0,    19,    16,
      17,     3,    14,    15,    55,     0,    82,     0,     0,    58,
       0,    84,    85,    86,    87,    88,    82,    82,    88,    82,
       4,    18,     0,    56,     0,    82,    82,    81,    82,     8,
       0,     0,    54,     0,    89,     0,    58,     0,    82,    58,
       0,    13,    82,    48,    34,     0,    35,     0,    82,    82,
      69,    67,    71,    64,    70,    68,    79,    80,    78,    66,
      65,    77,    72,    57,     0,    63,    60,    59,    74,    82,
       6,    37,    28,     0,    82,    82,     0,    20,    81,     0,
       0,    50,    82,    82,     0,     7,     0,    51,    53,    62,
      61,    76,    75,    73,     0,     0,    37,    37,    37,     0,
       0,     0,     0,     0,    10,    82,     0,    26,     0,    11,
      36,    33,    82,     0,     5,     0,    38,     0,    43,    44,
      19,    45,     0,    27,    21,    23,    31,    24,     0,    58,
       0,    46,     9,    49,     0,    37,    41,     0,    22,    82,
      25,    37,    47,    82,    42,    82,    12,    29,    30,    52,
      39,     0,    40
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,    11,    12,    32,    86,    87,   138,    55,   109,
     131,    56,    34,    42,    43,    73,    74,    75,    76,    77,
     103,    78,    19,    50,    25,    26
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -84
static const short yypact[] =
{
     -84,    38,   -84,    64,    54,   131,   143,    64,   -18,   -84,
     -84,   -84,   -84,   -84,   -17,   -10,    15,    30,    64,    96,
      61,   -84,   -84,   -84,   -84,   -84,    67,    15,    56,    47,
     -84,   -84,    64,   -84,    70,    67,    57,   -84,    67,   -84,
      71,    90,   -84,   130,   148,    64,   -84,    86,    15,   -84,
      86,   -84,    67,   -84,   109,    -5,   -84,    64,    18,    67,
     -84,   -84,   -84,   -84,   -84,   -84,   -84,   -84,   -84,   -84,
     -84,   -84,   -84,   -84,    87,   -84,   -84,   112,   144,    67,
     -84,    89,   114,    86,    15,    15,    64,    13,    99,    86,
      64,   -84,    67,    57,   111,   -84,   127,   -84,   -84,   -84,
     -84,   -84,   -84,   -84,    64,   133,    80,    89,    89,    20,
     101,   105,    86,    86,   -84,    75,   -20,   -84,    64,   -84,
     -84,   146,    67,    -3,   -84,   128,   -84,    53,   142,   142,
     -18,   -84,    86,   -84,   -84,   -84,   -84,   -84,     0,   -84,
     126,   -84,   -84,   -84,   149,    89,   118,    64,   -84,    -2,
     -84,    89,   -84,    67,   142,    82,   -84,   170,   142,   -84,
     -84,    11,   -84
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
     -84,   -84,   -84,     1,    59,   -39,   -84,   -63,    97,   -83,
     104,    -4,   -84,   -44,   -84,   -84,   -84,    69,   116,   117,
     -84,   -84,   -13,   -84,   188,     7
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -84
static const short yytable[] =
{
      18,    93,    81,    37,    13,    89,   149,    35,    30,   140,
      31,    90,    33,    29,    46,    47,    49,   149,    61,    39,
      16,    14,    45,   127,   128,   129,   136,   141,    15,    69,
      36,    53,    96,    51,    57,    88,    94,    16,     2,     3,
      16,   150,    38,     4,   111,     5,    80,     6,    91,     7,
     118,    79,   162,   115,    97,    98,     8,    14,    95,   116,
      14,   130,   154,   -32,    15,    44,   116,    15,   158,    48,
      14,   112,   113,   134,   135,   104,    16,    15,    16,    16,
       9,    10,    17,    52,   -82,    54,   157,   114,   120,    16,
      58,   119,   161,   148,   146,   151,   -82,    16,   -32,   116,
     -82,   -82,   139,   136,    16,   124,     9,    10,   105,    59,
     136,    40,    41,    92,    82,    99,   137,   105,   143,   142,
     106,   126,   110,   160,   107,   108,    83,   -83,   122,   106,
      84,    85,    60,   107,   108,    62,   139,    64,    65,   -83,
     123,   125,   139,   -83,   -83,   132,   133,    72,   156,   159,
      60,    61,    93,    62,    63,    64,    65,    66,   155,    20,
      67,    68,    69,    70,    71,    72,   101,    21,    22,    23,
      24,    66,   145,   152,    67,    68,   149,   153,    71,    21,
      22,    23,    24,    27,    21,    22,    23,    24,   116,   147,
     121,   117,   144,   100,    28,   102
};

static const unsigned char yycheck[] =
{
       4,     6,    46,    16,     3,    49,     6,    17,     7,    29,
      28,    50,    29,     6,    27,    28,    29,     6,    21,    18,
      22,     3,    26,   106,   107,   108,    28,    47,    10,    32,
      40,    35,    14,    32,    38,    48,    41,    22,     0,     1,
      22,    41,    12,     5,    83,     7,    45,     9,    52,    11,
      89,    44,    41,    40,    58,    59,    18,     3,    57,    46,
       3,    41,   145,     6,    10,     4,    46,    10,   151,    22,
       3,    84,    85,   112,   113,    79,    22,    10,    22,    22,
      42,    43,    28,    13,    28,    28,   149,    86,    92,    22,
      19,    90,   155,   132,    41,   139,    40,    22,    41,    46,
      44,    45,   115,    28,    22,   104,    42,    43,    28,    19,
      28,    15,    16,     4,    28,    28,    41,    28,   122,   118,
      40,    41,     8,    41,    44,    45,    40,    28,    17,    40,
      44,    45,    20,    44,    45,    23,   149,    25,    26,    40,
      13,     8,   155,    44,    45,    44,    41,    35,   147,   153,
      20,    21,     6,    23,    24,    25,    26,    27,    40,    28,
      30,    31,    32,    33,    34,    35,    22,    36,    37,    38,
      39,    27,    44,    47,    30,    31,     6,    28,    34,    36,
      37,    38,    39,    40,    36,    37,    38,    39,    46,   130,
      93,    87,   123,    77,     6,    78
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    49,     0,     1,     5,     7,     9,    11,    18,    42,
      43,    50,    51,    51,     3,    10,    22,    28,    59,    70,
      28,    36,    37,    38,    39,    72,    73,    40,    72,    73,
      51,    28,    52,    29,    60,    17,    40,    70,    12,    51,
      15,    16,    61,    62,     4,    59,    70,    70,    22,    70,
      71,    51,    13,    59,    28,    56,    59,    59,    19,    19,
      20,    21,    23,    24,    25,    26,    27,    30,    31,    32,
      33,    34,    35,    63,    64,    65,    66,    67,    69,    73,
      51,    61,    28,    40,    44,    45,    53,    54,    70,    61,
      53,    59,     4,     6,    41,    51,    14,    59,    59,    28,
      66,    22,    67,    68,    59,    28,    40,    44,    45,    57,
       8,    53,    70,    70,    51,    40,    46,    58,    53,    51,
      59,    56,    17,    13,    51,     8,    41,    57,    57,    57,
      41,    58,    44,    41,    53,    53,    28,    41,    55,    70,
      29,    47,    51,    59,    65,    44,    41,    52,    53,     6,
      41,    61,    47,    28,    57,    40,    51,    55,    57,    59,
      41,    55,    41
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 33 "cdgram.y"
    {
			prompt();
			prev = 0;
			}
    break;

  case 4:
#line 40 "cdgram.y"
    {
			Debug((stderr, "stmt: help\n"));
			dohelp();
			}
    break;

  case 5:
#line 46 "cdgram.y"
    {
			Debug((stderr, "stmt: DECLARE NAME AS opt_storage adecl\n"));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[-4].dynstr));
			Debug((stderr, "\topt_storage='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tacdecl.left='%s'\n", yyvsp[-1].halves.left));
			Debug((stderr, "\tacdecl.right='%s'\n", yyvsp[-1].halves.right));
			Debug((stderr, "\tacdecl.type='%s'\n", yyvsp[-1].halves.type));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			dodeclare(yyvsp[-4].dynstr, yyvsp[-2].dynstr, yyvsp[-1].halves.left, yyvsp[-1].halves.right, yyvsp[-1].halves.type);
			}
    break;

  case 6:
#line 58 "cdgram.y"
    {
			Debug((stderr, "stmt: DECLARE opt_storage adecl\n"));
			Debug((stderr, "\topt_storage='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tacdecl.left='%s'\n", yyvsp[-1].halves.left));
			Debug((stderr, "\tacdecl.right='%s'\n", yyvsp[-1].halves.right));
			Debug((stderr, "\tacdecl.type='%s'\n", yyvsp[-1].halves.type));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			dodeclare(NullCP, yyvsp[-2].dynstr, yyvsp[-1].halves.left, yyvsp[-1].halves.right, yyvsp[-1].halves.type);
			}
    break;

  case 7:
#line 69 "cdgram.y"
    {
			Debug((stderr, "stmt: CAST NAME AS adecl\n"));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\tacdecl.left='%s'\n", yyvsp[-1].halves.left));
			Debug((stderr, "\tacdecl.right='%s'\n", yyvsp[-1].halves.right));
			Debug((stderr, "\tacdecl.type='%s'\n", yyvsp[-1].halves.type));
			docast(yyvsp[-3].dynstr, yyvsp[-1].halves.left, yyvsp[-1].halves.right, yyvsp[-1].halves.type);
			}
    break;

  case 8:
#line 79 "cdgram.y"
    {
			Debug((stderr, "stmt: CAST adecl\n"));
			Debug((stderr, "\tacdecl.left='%s'\n", yyvsp[-1].halves.left));
			Debug((stderr, "\tacdecl.right='%s'\n", yyvsp[-1].halves.right));
			Debug((stderr, "\tacdecl.type='%s'\n", yyvsp[-1].halves.type));
			docast(NullCP, yyvsp[-1].halves.left, yyvsp[-1].halves.right, yyvsp[-1].halves.type);
			}
    break;

  case 9:
#line 88 "cdgram.y"
    {
			Debug((stderr, "stmt: EXPLAIN opt_storage opt_constvol_list type cdecl\n"));
			Debug((stderr, "\topt_storage='%s'\n", yyvsp[-4].dynstr));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\ttype='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tcdecl='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			dodexplain(yyvsp[-4].dynstr, yyvsp[-3].dynstr, yyvsp[-2].dynstr, yyvsp[-1].dynstr);
			}
    break;

  case 10:
#line 99 "cdgram.y"
    {
			Debug((stderr, "stmt: EXPLAIN storage opt_constvol_list cdecl\n"));
			Debug((stderr, "\tstorage='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tcdecl='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			dodexplain(yyvsp[-3].dynstr, yyvsp[-2].dynstr, NullCP, yyvsp[-1].dynstr);
			}
    break;

  case 11:
#line 109 "cdgram.y"
    {
			Debug((stderr, "stmt: EXPLAIN opt_storage constvol_list cdecl\n"));
			Debug((stderr, "\topt_storage='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\tconstvol_list='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tcdecl='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			dodexplain(yyvsp[-3].dynstr, yyvsp[-2].dynstr, NullCP, yyvsp[-1].dynstr);
			}
    break;

  case 12:
#line 119 "cdgram.y"
    {
			Debug((stderr, "stmt: EXPLAIN ( opt_constvol_list type cast ) optNAME\n"));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-5].dynstr));
			Debug((stderr, "\ttype='%s'\n", yyvsp[-4].dynstr));
			Debug((stderr, "\tcast='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			docexplain(yyvsp[-5].dynstr, yyvsp[-4].dynstr, yyvsp[-3].dynstr, yyvsp[-1].dynstr);
			}
    break;

  case 13:
#line 130 "cdgram.y"
    {
			Debug((stderr, "stmt: SET optNAME\n"));
			Debug((stderr, "\toptNAME='%s'\n", yyvsp[-1].dynstr));
			doset(yyvsp[-1].dynstr);
			}
    break;

  case 15:
#line 138 "cdgram.y"
    {
			yyerrok;
			}
    break;

  case 16:
#line 144 "cdgram.y"
    {
			doprompt();
			}
    break;

  case 17:
#line 148 "cdgram.y"
    {
			noprompt();
			}
    break;

  case 18:
#line 154 "cdgram.y"
    {
			Debug((stderr, "optNAME: NAME\n"));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 19:
#line 161 "cdgram.y"
    {
			Debug((stderr, "optNAME: EMPTY\n"));
			yyval.dynstr = ds(unknown_name);
			}
    break;

  case 21:
#line 169 "cdgram.y"
    {
			Debug((stderr, "cdecl: * opt_constvol_list cdecl\n"));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tcdecl='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[0].dynstr,yyvsp[-1].dynstr,ds(strlen(yyvsp[-1].dynstr)?" pointer to ":"pointer to "),NullCP);
			prev = 'p';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 22:
#line 179 "cdgram.y"
    {
			Debug((stderr, "cdecl: NAME DOUBLECOLON '*' cdecl\n"));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\tcdecl='%s'\n", yyvsp[0].dynstr));
			if (!CplusplusFlag)
				unsupp("pointer to member of class", NullCP);
			yyval.dynstr = cat(yyvsp[0].dynstr,ds("pointer to member of class "),yyvsp[-3].dynstr,ds(" "),NullCP);
			prev = 'p';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 23:
#line 191 "cdgram.y"
    {
			Debug((stderr, "cdecl: & opt_constvol_list cdecl\n"));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tcdecl='%s'\n", yyvsp[0].dynstr));
			if (!CplusplusFlag)
				unsupp("reference", NullCP);
			yyval.dynstr = cat(yyvsp[0].dynstr,yyvsp[-1].dynstr,ds(strlen(yyvsp[-1].dynstr)?" reference to ":"reference to "),NullCP);
			prev = 'r';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 24:
#line 204 "cdgram.y"
    {
			Debug((stderr, "cdecl1: cdecl1()\n"));
			Debug((stderr, "\tcdecl1='%s'\n", yyvsp[-2].dynstr));
			yyval.dynstr = cat(yyvsp[-2].dynstr,ds("function returning "),NullCP);
			prev = 'f';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 25:
#line 213 "cdgram.y"
    {
			Debug((stderr, "cdecl1: cdecl1(castlist)\n"));
			Debug((stderr, "\tcdecl1='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\tcastlist='%s'\n", yyvsp[-1].dynstr));
			yyval.dynstr = cat(yyvsp[-3].dynstr, ds("function ("),
				  yyvsp[-1].dynstr, ds(") returning "), NullCP);
			prev = 'f';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 26:
#line 224 "cdgram.y"
    {
			Debug((stderr, "cdecl1: cdecl1 cdims\n"));
			Debug((stderr, "\tcdecl1='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tcdims='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[-1].dynstr,ds("array "),yyvsp[0].dynstr,NullCP);
			prev = 'a';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 27:
#line 234 "cdgram.y"
    {
			Debug((stderr, "cdecl1: (cdecl)\n"));
			Debug((stderr, "\tcdecl='%s'\n", yyvsp[-1].dynstr));
			yyval.dynstr = yyvsp[-1].dynstr;
			/* prev = prev; */
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 28:
#line 243 "cdgram.y"
    {
			Debug((stderr, "cdecl1: NAME\n"));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[0].dynstr));
			savedname = yyvsp[0].dynstr;
			yyval.dynstr = ds("");
			prev = 'n';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 29:
#line 254 "cdgram.y"
    {
			Debug((stderr, "castlist: castlist1, castlist2\n"));
			Debug((stderr, "\tcastlist1='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tcastlist2='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[-2].dynstr, ds(", "), yyvsp[0].dynstr, NullCP);
			}
    break;

  case 30:
#line 262 "cdgram.y"
    {
			Debug((stderr, "castlist: opt_constvol_list type cast\n"));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\ttype='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tcast='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[0].dynstr, yyvsp[-2].dynstr, ds(strlen(yyvsp[-2].dynstr) ? " " : ""), yyvsp[-1].dynstr, NullCP);
			}
    break;

  case 31:
#line 271 "cdgram.y"
    {
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 32:
#line 277 "cdgram.y"
    {
			Debug((stderr, "adecllist: EMPTY\n"));
			yyval.dynstr = ds("");
			}
    break;

  case 33:
#line 283 "cdgram.y"
    {
			Debug((stderr, "adecllist: adecllist1, adecllist2\n"));
			Debug((stderr, "\tadecllist1='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tadecllist2='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[-2].dynstr, ds(", "), yyvsp[0].dynstr, NullCP);
			}
    break;

  case 34:
#line 291 "cdgram.y"
    {
			Debug((stderr, "adecllist: NAME\n"));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 35:
#line 298 "cdgram.y"
    {
			Debug((stderr, "adecllist: adecl\n"));
			Debug((stderr, "\tadecl.left='%s'\n", yyvsp[0].halves.left));
			Debug((stderr, "\tadecl.right='%s'\n", yyvsp[0].halves.right));
			Debug((stderr, "\tadecl.type='%s'\n", yyvsp[0].halves.type));
			yyval.dynstr = cat(yyvsp[0].halves.type, ds(" "), yyvsp[0].halves.left, yyvsp[0].halves.right, NullCP);
			}
    break;

  case 36:
#line 307 "cdgram.y"
    {
			Debug((stderr, "adecllist: NAME AS adecl\n"));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tadecl.left='%s'\n", yyvsp[0].halves.left));
			Debug((stderr, "\tadecl.right='%s'\n", yyvsp[0].halves.right));
			Debug((stderr, "\tadecl.type='%s'\n", yyvsp[0].halves.type));
			yyval.dynstr = cat(yyvsp[0].halves.type, ds(" "), yyvsp[0].halves.left, yyvsp[-2].dynstr, yyvsp[0].halves.right, NullCP);
			}
    break;

  case 37:
#line 318 "cdgram.y"
    {
			Debug((stderr, "cast: EMPTY\n"));
			yyval.dynstr = ds("");
			/* prev = prev; */
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 38:
#line 326 "cdgram.y"
    {
			Debug((stderr, "cast: ()\n"));
			yyval.dynstr = ds("function returning ");
			prev = 'f';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 39:
#line 334 "cdgram.y"
    {
			Debug((stderr, "cast: (cast)()\n"));
			Debug((stderr, "\tcast='%s'\n", yyvsp[-3].dynstr));
			yyval.dynstr = cat(yyvsp[-3].dynstr,ds("function returning "),NullCP);
			prev = 'f';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 40:
#line 343 "cdgram.y"
    {
			Debug((stderr, "cast: (cast)(castlist)\n"));
			Debug((stderr, "\tcast='%s'\n", yyvsp[-4].dynstr));
			Debug((stderr, "\tcastlist='%s'\n", yyvsp[-1].dynstr));
			yyval.dynstr = cat(yyvsp[-4].dynstr,ds("function ("),yyvsp[-1].dynstr,ds(") returning "),NullCP);
			prev = 'f';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 41:
#line 353 "cdgram.y"
    {
			Debug((stderr, "cast: (cast)\n"));
			Debug((stderr, "\tcast='%s'\n", yyvsp[-1].dynstr));
			yyval.dynstr = yyvsp[-1].dynstr;
			/* prev = prev; */
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 42:
#line 362 "cdgram.y"
    {
			Debug((stderr, "cast: NAME::*cast\n"));
			Debug((stderr, "\tcast='%s'\n", yyvsp[0].dynstr));
			if (!CplusplusFlag)
				unsupp("pointer to member of class", NullCP);
			yyval.dynstr = cat(yyvsp[0].dynstr,ds("pointer to member of class "),yyvsp[-3].dynstr,ds(" "),NullCP);
			prev = 'p';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 43:
#line 373 "cdgram.y"
    {
			Debug((stderr, "cast: *cast\n"));
			Debug((stderr, "\tcast='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[0].dynstr,ds("pointer to "),NullCP);
			prev = 'p';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 44:
#line 382 "cdgram.y"
    {
			Debug((stderr, "cast: &cast\n"));
			Debug((stderr, "\tcast='%s'\n", yyvsp[0].dynstr));
			if (!CplusplusFlag)
				unsupp("reference", NullCP);
			yyval.dynstr = cat(yyvsp[0].dynstr,ds("reference to "),NullCP);
			prev = 'r';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 45:
#line 393 "cdgram.y"
    {
			Debug((stderr, "cast: cast cdims\n"));
			Debug((stderr, "\tcast='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tcdims='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[-1].dynstr,ds("array "),yyvsp[0].dynstr,NullCP);
			prev = 'a';
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 46:
#line 404 "cdgram.y"
    {
			Debug((stderr, "cdims: []\n"));
			yyval.dynstr = ds("of ");
			}
    break;

  case 47:
#line 410 "cdgram.y"
    {
			Debug((stderr, "cdims: [NUMBER]\n"));
			Debug((stderr, "\tNUMBER='%s'\n", yyvsp[-1].dynstr));
			yyval.dynstr = cat(yyvsp[-1].dynstr,ds(" of "),NullCP);
			}
    break;

  case 48:
#line 418 "cdgram.y"
    {
			Debug((stderr, "adecl: FUNCTION RETURNING adecl\n"));
			Debug((stderr, "\tadecl.left='%s'\n", yyvsp[0].halves.left));
			Debug((stderr, "\tadecl.right='%s'\n", yyvsp[0].halves.right));
			Debug((stderr, "\tadecl.type='%s'\n", yyvsp[0].halves.type));
			if (prev == 'f')
				unsupp("Function returning function",
				       "function returning pointer to function");
			else if (prev=='A' || prev=='a')
				unsupp("Function returning array",
				       "function returning pointer");
			yyval.halves.left = yyvsp[0].halves.left;
			yyval.halves.right = cat(ds("()"),yyvsp[0].halves.right,NullCP);
			yyval.halves.type = yyvsp[0].halves.type;
			prev = 'f';
			Debug((stderr, "\n\tadecl now =\n"));
			Debug((stderr, "\t\tadecl.left='%s'\n", yyval.halves.left));
			Debug((stderr, "\t\tadecl.right='%s'\n", yyval.halves.right));
			Debug((stderr, "\t\tadecl.type='%s'\n", yyval.halves.type));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 49:
#line 441 "cdgram.y"
    {
			Debug((stderr, "adecl: FUNCTION (adecllist) RETURNING adecl\n"));
			Debug((stderr, "\tadecllist='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\tadecl.left='%s'\n", yyvsp[0].halves.left));
			Debug((stderr, "\tadecl.right='%s'\n", yyvsp[0].halves.right));
			Debug((stderr, "\tadecl.type='%s'\n", yyvsp[0].halves.type));
			if (prev == 'f')
				unsupp("Function returning function",
				       "function returning pointer to function");
			else if (prev=='A' || prev=='a')
				unsupp("Function returning array",
				       "function returning pointer");
			yyval.halves.left = yyvsp[0].halves.left;
			yyval.halves.right = cat(ds("("),yyvsp[-3].dynstr,ds(")"),yyvsp[0].halves.right,NullCP);
			yyval.halves.type = yyvsp[0].halves.type;
			prev = 'f';
			Debug((stderr, "\n\tadecl now =\n"));
			Debug((stderr, "\t\tadecl.left='%s'\n", yyval.halves.left));
			Debug((stderr, "\t\tadecl.right='%s'\n", yyval.halves.right));
			Debug((stderr, "\t\tadecl.type='%s'\n", yyval.halves.type));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 50:
#line 465 "cdgram.y"
    {
			Debug((stderr, "adecl: ARRAY adims OF adecl\n"));
			Debug((stderr, "\tadims='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tadecl.left='%s'\n", yyvsp[0].halves.left));
			Debug((stderr, "\tadecl.right='%s'\n", yyvsp[0].halves.right));
			Debug((stderr, "\tadecl.type='%s'\n", yyvsp[0].halves.type));
			if (prev == 'f')
				unsupp("Array of function",
				       "array of pointer to function");
			else if (prev == 'a')
				unsupp("Inner array of unspecified size",
				       "array of pointer");
			else if (prev == 'v')
				unsupp("Array of void",
				       "pointer to void");
			if (arbdims)
				prev = 'a';
			else
				prev = 'A';
			yyval.halves.left = yyvsp[0].halves.left;
			yyval.halves.right = cat(yyvsp[-2].dynstr,yyvsp[0].halves.right,NullCP);
			yyval.halves.type = yyvsp[0].halves.type;
			Debug((stderr, "\n\tadecl now =\n"));
			Debug((stderr, "\t\tadecl.left='%s'\n", yyval.halves.left));
			Debug((stderr, "\t\tadecl.right='%s'\n", yyval.halves.right));
			Debug((stderr, "\t\tadecl.type='%s'\n", yyval.halves.type));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 51:
#line 495 "cdgram.y"
    {
			char *op = "", *cp = "", *sp = "";

			Debug((stderr, "adecl: opt_constvol_list POINTER TO adecl\n"));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\tadecl.left='%s'\n", yyvsp[0].halves.left));
			Debug((stderr, "\tadecl.right='%s'\n", yyvsp[0].halves.right));
			Debug((stderr, "\tadecl.type='%s'\n", yyvsp[0].halves.type));
			if (prev == 'a')
				unsupp("Pointer to array of unspecified dimension",
				       "pointer to object");
			if (prev=='a' || prev=='A' || prev=='f') {
				op = "(";
				cp = ")";
			}
			if (strlen(yyvsp[-3].dynstr) != 0)
				sp = " ";
			yyval.halves.left = cat(yyvsp[0].halves.left,ds(op),ds("*"),
				       ds(sp),yyvsp[-3].dynstr,ds(sp),NullCP);
			yyval.halves.right = cat(ds(cp),yyvsp[0].halves.right,NullCP);
			yyval.halves.type = yyvsp[0].halves.type;
			prev = 'p';
			Debug((stderr, "\n\tadecl now =\n"));
			Debug((stderr, "\t\tadecl.left='%s'\n", yyval.halves.left));
			Debug((stderr, "\t\tadecl.right='%s'\n", yyval.halves.right));
			Debug((stderr, "\t\tadecl.type='%s'\n", yyval.halves.type));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 52:
#line 525 "cdgram.y"
    {
			char *op = "", *cp = "", *sp = "";

			Debug((stderr, "adecl: opt_constvol_list POINTER TO MEMBER OF ClassStruct NAME adecl\n"));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-7].dynstr));
			Debug((stderr, "\tClassStruct='%s'\n", yyvsp[-2].dynstr));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tadecl.left='%s'\n", yyvsp[0].halves.left));
			Debug((stderr, "\tadecl.right='%s'\n", yyvsp[0].halves.right));
			Debug((stderr, "\tadecl.type='%s'\n", yyvsp[0].halves.type));
			if (!CplusplusFlag)
				unsupp("pointer to member of class", NullCP);
			if (prev == 'a')
				unsupp("Pointer to array of unspecified dimension",
				       "pointer to object");
			if (prev=='a' || prev=='A' || prev=='f') {
				op = "(";
				cp = ")";
			}
			if (strlen(yyvsp[-7].dynstr) != 0)
				sp = " ";
			yyval.halves.left = cat(yyvsp[0].halves.left,ds(op),yyvsp[-1].dynstr,ds("::*"),
				      ds(sp),yyvsp[-7].dynstr,ds(sp),NullCP);
			yyval.halves.right = cat(ds(cp),yyvsp[0].halves.right,NullCP);
			yyval.halves.type = yyvsp[0].halves.type;
			prev = 'p';
			Debug((stderr, "\n\tadecl now =\n"));
			Debug((stderr, "\t\tadecl.left='%s'\n", yyval.halves.left));
			Debug((stderr, "\t\tadecl.right='%s'\n", yyval.halves.right));
			Debug((stderr, "\t\tadecl.type='%s'\n", yyval.halves.type));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 53:
#line 559 "cdgram.y"
    {
			char *op = "", *cp = "", *sp = "";

			Debug((stderr, "adecl: opt_constvol_list REFERENCE TO adecl\n"));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-3].dynstr));
			Debug((stderr, "\tadecl.left='%s'\n", yyvsp[0].halves.left));
			Debug((stderr, "\tadecl.right='%s'\n", yyvsp[0].halves.right));
			Debug((stderr, "\tadecl.type='%s'\n", yyvsp[0].halves.type));
			if (!CplusplusFlag)
				unsupp("reference", NullCP);
			if (prev == 'v')
				unsupp("Reference to void",
				       "pointer to void");
			else if (prev == 'a')
				unsupp("Reference to array of unspecified dimension",
				       "reference to object");
			if (prev=='a' || prev=='A' || prev=='f') {
				op = "(";
				cp = ")";
			}
			if (strlen(yyvsp[-3].dynstr) != 0)
				sp = " ";
			yyval.halves.left = cat(yyvsp[0].halves.left,ds(op),ds("&"),
				       ds(sp),yyvsp[-3].dynstr,ds(sp),NullCP);
			yyval.halves.right = cat(ds(cp),yyvsp[0].halves.right,NullCP);
			yyval.halves.type = yyvsp[0].halves.type;
			prev = 'r';
			Debug((stderr, "\n\tadecl now =\n"));
			Debug((stderr, "\t\tadecl.left='%s'\n", yyval.halves.left));
			Debug((stderr, "\t\tadecl.right='%s'\n", yyval.halves.right));
			Debug((stderr, "\t\tadecl.type='%s'\n", yyval.halves.type));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 54:
#line 594 "cdgram.y"
    {
			Debug((stderr, "adecl: opt_constvol_list type\n"));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\ttype='%s'\n", yyvsp[0].dynstr));
			yyval.halves.left = ds("");
			yyval.halves.right = ds("");
			yyval.halves.type = cat(yyvsp[-1].dynstr,ds(strlen(yyvsp[-1].dynstr)?" ":""),yyvsp[0].dynstr,NullCP);
			if (strcmp(yyvsp[0].dynstr, "void") == 0)
			    prev = 'v';
			else if ((strncmp(yyvsp[0].dynstr, "struct", 6) == 0) ||
			         (strncmp(yyvsp[0].dynstr, "class", 5) == 0))
			    prev = 's';
			else
			    prev = 't';
			Debug((stderr, "\n\tadecl now =\n"));
			Debug((stderr, "\t\tadecl.left='%s'\n", yyval.halves.left));
			Debug((stderr, "\t\tadecl.right='%s'\n", yyval.halves.right));
			Debug((stderr, "\t\tadecl.type='%s'\n", yyval.halves.type));
			Debug((stderr, "\tprev = '%s'\n", visible(prev)));
			}
    break;

  case 55:
#line 617 "cdgram.y"
    {
			Debug((stderr, "adims: EMPTY\n"));
			arbdims = 1;
			yyval.dynstr = ds("[]");
			}
    break;

  case 56:
#line 624 "cdgram.y"
    {
			Debug((stderr, "adims: NUMBER\n"));
			Debug((stderr, "\tNUMBER='%s'\n", yyvsp[0].dynstr));
			arbdims = 0;
			yyval.dynstr = cat(ds("["),yyvsp[0].dynstr,ds("]"),NullCP);
			}
    break;

  case 57:
#line 633 "cdgram.y"
    {
			Debug((stderr, "type: tinit c_type\n"));
			Debug((stderr, "\ttinit=''\n"));
			Debug((stderr, "\tc_type='%s'\n", yyvsp[0].dynstr));
			mbcheck();
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 58:
#line 643 "cdgram.y"
    {
			Debug((stderr, "tinit: EMPTY\n"));
			modbits = 0;
			}
    break;

  case 59:
#line 650 "cdgram.y"
    {
			Debug((stderr, "c_type: mod_list\n"));
			Debug((stderr, "\tmod_list='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 60:
#line 657 "cdgram.y"
    {
			Debug((stderr, "c_type: tname\n"));
			Debug((stderr, "\ttname='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 61:
#line 664 "cdgram.y"
    {
			Debug((stderr, "c_type: mod_list tname\n"));
			Debug((stderr, "\tmod_list='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\ttname='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[-1].dynstr,ds(" "),yyvsp[0].dynstr,NullCP);
			}
    break;

  case 62:
#line 672 "cdgram.y"
    {
			Debug((stderr, "c_type: StrClaUniEnum NAME\n"));
			Debug((stderr, "\tStrClaUniEnum='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tNAME='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[-1].dynstr,ds(" "),yyvsp[0].dynstr,NullCP);
			}
    break;

  case 65:
#line 683 "cdgram.y"
    {
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 67:
#line 690 "cdgram.y"
    {
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 68:
#line 696 "cdgram.y"
    {
			Debug((stderr, "tname: INT\n"));
			Debug((stderr, "\tINT='%s'\n", yyvsp[0].dynstr));
			modbits |= MB_INT; yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 69:
#line 703 "cdgram.y"
    {
			Debug((stderr, "tname: CHAR\n"));
			Debug((stderr, "\tCHAR='%s'\n", yyvsp[0].dynstr));
			modbits |= MB_CHAR; yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 70:
#line 710 "cdgram.y"
    {
			Debug((stderr, "tname: FLOAT\n"));
			Debug((stderr, "\tFLOAT='%s'\n", yyvsp[0].dynstr));
			modbits |= MB_FLOAT; yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 71:
#line 717 "cdgram.y"
    {
			Debug((stderr, "tname: DOUBLE\n"));
			Debug((stderr, "\tDOUBLE='%s'\n", yyvsp[0].dynstr));
			modbits |= MB_DOUBLE; yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 72:
#line 724 "cdgram.y"
    {
			Debug((stderr, "tname: VOID\n"));
			Debug((stderr, "\tVOID='%s'\n", yyvsp[0].dynstr));
			modbits |= MB_VOID; yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 73:
#line 732 "cdgram.y"
    {
			Debug((stderr, "mod_list: modifier mod_list1\n"));
			Debug((stderr, "\tmodifier='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\tmod_list1='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = cat(yyvsp[-1].dynstr,ds(" "),yyvsp[0].dynstr,NullCP);
			}
    break;

  case 74:
#line 740 "cdgram.y"
    {
			Debug((stderr, "mod_list: modifier\n"));
			Debug((stderr, "\tmodifier='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 75:
#line 748 "cdgram.y"
    {
			Debug((stderr, "mod_list1: mod_list\n"));
			Debug((stderr, "\tmod_list='%s'\n", yyvsp[0].dynstr));
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 76:
#line 755 "cdgram.y"
    {
			Debug((stderr, "mod_list1: CONSTVOLATILE\n"));
			Debug((stderr, "\tCONSTVOLATILE='%s'\n", yyvsp[0].dynstr));
			if (PreANSIFlag)
				notsupported(" (Pre-ANSI Compiler)", yyvsp[0].dynstr, NullCP);
			else if (RitchieFlag)
				notsupported(" (Ritchie Compiler)", yyvsp[0].dynstr, NullCP);
			else if ((strcmp(yyvsp[0].dynstr, "noalias") == 0) && CplusplusFlag)
				unsupp(yyvsp[0].dynstr, NullCP);
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 77:
#line 769 "cdgram.y"
    {
			Debug((stderr, "modifier: UNSIGNED\n"));
			Debug((stderr, "\tUNSIGNED='%s'\n", yyvsp[0].dynstr));
			modbits |= MB_UNSIGNED; yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 78:
#line 776 "cdgram.y"
    {
			Debug((stderr, "modifier: SIGNED\n"));
			Debug((stderr, "\tSIGNED='%s'\n", yyvsp[0].dynstr));
			modbits |= MB_SIGNED; yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 79:
#line 783 "cdgram.y"
    {
			Debug((stderr, "modifier: LONG\n"));
			Debug((stderr, "\tLONG='%s'\n", yyvsp[0].dynstr));
			modbits |= MB_LONG; yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 80:
#line 790 "cdgram.y"
    {
			Debug((stderr, "modifier: SHORT\n"));
			Debug((stderr, "\tSHORT='%s'\n", yyvsp[0].dynstr));
			modbits |= MB_SHORT; yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 81:
#line 798 "cdgram.y"
    {
			Debug((stderr, "opt_constvol_list: CONSTVOLATILE opt_constvol_list\n"));
			Debug((stderr, "\tCONSTVOLATILE='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[0].dynstr));
			if (PreANSIFlag)
				notsupported(" (Pre-ANSI Compiler)", yyvsp[-1].dynstr, NullCP);
			else if (RitchieFlag)
				notsupported(" (Ritchie Compiler)", yyvsp[-1].dynstr, NullCP);
			else if ((strcmp(yyvsp[-1].dynstr, "noalias") == 0) && CplusplusFlag)
				unsupp(yyvsp[-1].dynstr, NullCP);
			yyval.dynstr = cat(yyvsp[-1].dynstr,ds(strlen(yyvsp[0].dynstr) ? " " : ""),yyvsp[0].dynstr,NullCP);
			}
    break;

  case 82:
#line 812 "cdgram.y"
    {
			Debug((stderr, "opt_constvol_list: EMPTY\n"));
			yyval.dynstr = ds("");
			}
    break;

  case 83:
#line 819 "cdgram.y"
    {
			Debug((stderr, "constvol_list: CONSTVOLATILE opt_constvol_list\n"));
			Debug((stderr, "\tCONSTVOLATILE='%s'\n", yyvsp[-1].dynstr));
			Debug((stderr, "\topt_constvol_list='%s'\n", yyvsp[0].dynstr));
			if (PreANSIFlag)
				notsupported(" (Pre-ANSI Compiler)", yyvsp[-1].dynstr, NullCP);
			else if (RitchieFlag)
				notsupported(" (Ritchie Compiler)", yyvsp[-1].dynstr, NullCP);
			else if ((strcmp(yyvsp[-1].dynstr, "noalias") == 0) && CplusplusFlag)
				unsupp(yyvsp[-1].dynstr, NullCP);
			yyval.dynstr = cat(yyvsp[-1].dynstr,ds(strlen(yyvsp[0].dynstr) ? " " : ""),yyvsp[0].dynstr,NullCP);
			}
    break;

  case 87:
#line 837 "cdgram.y"
    {
			Debug((stderr, "storage: AUTO,EXTERN,STATIC,REGISTER (%s)\n", yyvsp[0].dynstr));
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 88:
#line 844 "cdgram.y"
    {
			Debug((stderr, "opt_storage: storage=%s\n", yyvsp[0].dynstr));
			yyval.dynstr = yyvsp[0].dynstr;
			}
    break;

  case 89:
#line 850 "cdgram.y"
    {
			Debug((stderr, "opt_storage: EMPTY\n"));
			yyval.dynstr = ds("");
			}
    break;


    }

/* Line 999 of yacc.c.  */
#line 2159 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 855 "cdgram.y"



